#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n,k;
    cin>>n>>k;
    long long niz[n];
    for(int i=0;i<n;i++)
    {
        cin>>niz[i];
    }
    long long a=0;
    for(int i=0;i<n;i++)
    {
        long long x=1;
        int ok1=0;
        for(int j=1;j<=k;j++)
        {
            x*=(i+j);
            if(x%k==0)
            {
                x/=k;
                ok1=1;
            }
            if(ok1==1)
            {
                x%=1000000007;
            }

        }
        int ok2=0;
        for(int j=0;j<k;j++)
        {
            x*=(n-i-j);
            if(x%k==0)
            {
                x/=k;
                ok2=1;
            }
            if(ok2==1)
            {
                x%=1000000007;
            }
        }
        a+=x*(niz[i]);
    }
    cout<<a;
}